#!/bin/bash
#
# Setup the IPv6 NDP proxy addresses
# This is the only way to be able to answer to ICMPv6 Neighbour Sollicitation requests coming from customer networks
#
# Description:
#  The application is launched as root (it is important because "ip" command needs root access to modify the routing tables, otherwise it gets error from the kernel).
#  It listen using netcat on localhost, tcp port 7373 to get either a Connect for an IP6 or a Disconnect.
#  [C]onnect will add the given IP6 to the proxy neighbour table: [D]isconnect will remove it.
#
# by Pascal Pannnels, Belnet, 20220914
#
# v0.1 : initial version (20220915)
#

while ( true ); do
while read line; do
  cmd="${line:0:1}"
  address="${line:2}"

  case $cmd in
    "C")
       ip -6 neigh add proxy $address dev eth1
       ;;
    "D")
       ip -6 neigh del proxy $address dev eth1
       ;;
  esac
done < <( ncat -l 127.0.0.1 7373 --keep-open )
done

